// Canon BubbleJet BJ130e & compatibles models driver Class
//
// 2001, Philippe Houdoin
// Based on gsbj10e.c GhostScript driver
// - gdevbjc.h, gdevbjcl.h, gdevbjcl.c from GhostScript
// - LMDriver.cpp from Ryan Lockhart Lexmark 5/7xxxx BeOS driver 
//
// Printers supported
//   bj10e, bj10ex, bj10sx, bj20, bj130e, bj300 and bj330
// 
// Todo list:
// - all! ;-)

#define DEBUG	1

#include <Debug.h>

#include <stdio.h>
#include <string.h>			// for memset()

#include "BJ130e.h"

#define ROUND_UP(x, y) (((x) + (y) - 1) & ~((y) - 1))


// Constructor & destructor
// ------------------------

BJ130e::BJ130e()
	: Printer()
{
	x_resolution 	= 180;	// 180 dpi
	y_resolution 	= 180;	// 180 dpi
	
	m_page_bitmap		= NULL;
}


BJ130e::~BJ130e()
{
	if ( m_page_bitmap )
	 	delete m_page_bitmap;
	
	if ( transport )
		{
		ExitPrinter();
		CloseTransport();
		};
}

// Methods
// -------

status_t BJ130e::PrintPage
	(
	BFile *		spool,
	BMessage *	job_msg,
	int32		page_number,
	int32		page_count
	)
{
	return B_ERROR;
}


status_t BJ130e::InitPrinter()
{
	return B_OK;
}


status_t BJ130e::ExitPrinter()
{
	if (! transport)
		return B_ERROR;
		
	return B_OK;
}



status_t BJ130e::BeginPage()
{
	// Carriage Return...
	return transport->Write("\x0d", 1);
}



status_t BJ130e::EndPage()
{
	// Form Feed
	return transport->Write("\x0c", 1);
}


status_t BJ130e::WriteLoHi(int value)
{
	uint8 tmp[2];
	
	tmp[0] = (value & 0xff);
	tmp[1] = (value & 0xffff) >> 8;
	
	return transport->Write(tmp, 2);
}

	 
status_t BJ130e::WriteHiLo(int value)
{
	uint8 tmp[2];
	
	tmp[0] = (value & 0xffff) >> 8;
	tmp[1] = (value & 0xff);
	
	return transport->Write(tmp, 2);
}
 



