#ifndef BJC_H
#define BJC_H

#include <AppKit.h>
#include <InterfaceKit.h>

#include "Printer.h"

#define SCALE 8.3333f
#define SCREEN 72.0f
#define LETTER_WIDTH 8.5
#define LETTER_HEIGHT 11

class BJC : public Printer
	{
	public:
		// constructors / destructor
		BJC();
		~BJC();
		
		// public methods
		status_t 			PrintPage(BFile * spool, BMessage * job_msg, int32 page_number, int32 page_count);

		status_t			InitPrinter();
		status_t			ExitPrinter();
		status_t			BeginPage();
		status_t			EndPage();
		
		status_t 			AdvancePaper(int count);
		status_t			AdvanceHead(int count);
		
		status_t			RasterizePage(BFile * spool, BMessage * msg);
		
	private:
		int 				BuildScanLine(const uint8 * frame, int width, uint8 * compressed);
		int 				CompressFrame(const uint8 * frame, int width, uint8 * compressed);
		
		status_t			WriteCommand(uint8 command, int length = 0, const void * data = NULL);
		status_t			WriteHiLo(int value);
		status_t			WriteLoHi(int value);


	
		BBitmap *			m_page_bitmap;
	};

#endif	// #if BJC_H
